diff -Naurp asterisk-1.8.5.0.orig/main/utils.c asterisk-1.8.5.0.patched/main/utils.c
--- asterisk-1.8.5.0.orig/main/utils.c	2011-06-09 16:06:42.000000000 +0200
+++ asterisk-1.8.5.0.patched/main/utils.c	2011-08-06 16:28:36.568645492 +0200
@@ -1647,9 +1647,12 @@ ast_string_field __ast_string_field_allo
 	char *result = NULL;
 	size_t space = (*pool_head)->size - (*pool_head)->used;
 	size_t to_alloc = needed + sizeof(ast_string_field_allocation);
+#if defined __sparc__ || defined __arm__
+	size_t align;
+#endif
 
-	/* This +1 accounts for alignment on SPARC */
-	if (__builtin_expect(to_alloc + 1 > space, 0)) {
+	/* The add accounts for alignment on SPARC */
+	if (__builtin_expect(to_alloc + (sizeof(ast_string_field_allocation) - 1) > space, 0)) {
 		size_t new_size = (*pool_head)->size;
 
 		while (new_size < to_alloc) {
@@ -1666,12 +1669,11 @@ ast_string_field __ast_string_field_allo
 	}
 
 	result = (*pool_head)->base + (*pool_head)->used;
-#ifdef __sparc__
+#if defined __sparc__ || defined __arm__
 	/* SPARC requires that the allocation field be aligned. */
-	if ((long) result % sizeof(ast_string_field_allocation)) {
-		result++;
-		(*pool_head)->used++;
-	}
+	align = (sizeof(ast_string_field_allocation) - ((long) result & (sizeof(ast_string_field_allocation) - 1))) & (sizeof(ast_string_field_allocation) - 1);
+	result += align;
+	(*pool_head)->used += align;
 #endif
 	(*pool_head)->used += to_alloc;
 	(*pool_head)->active += needed;
@@ -1732,6 +1734,9 @@ void __ast_string_field_ptr_build_va(str
 	size_t needed;
 	size_t available;
 	size_t space = (*pool_head)->size - (*pool_head)->used;
+#if defined __sparc__ || defined __arm__
+	size_t align = 0;
+#endif
 	ssize_t grow;
 	char *target;
 
@@ -1746,13 +1751,13 @@ void __ast_string_field_ptr_build_va(str
 			available += space;
 		}
 	} else {
-		target = (*pool_head)->base + (*pool_head)->used + sizeof(ast_string_field_allocation);
-#ifdef __sparc__
-		if ((long) target % sizeof(ast_string_field_allocation)) {
-			target++;
-			space--;
-		}
+		target = (*pool_head)->base + (*pool_head)->used;
+#if defined __sparc__ || defined __arm__
+		align = (sizeof(ast_string_field_allocation) - ((long) target & (sizeof(ast_string_field_allocation) - 1))) & (sizeof(ast_string_field_allocation) - 1);
+		target += align;
+		space -= align;
 #endif
+		target += sizeof(ast_string_field_allocation);
 		available = space - sizeof(ast_string_field_allocation);
 	}
 
@@ -1778,7 +1783,11 @@ void __ast_string_field_ptr_build_va(str
 		__ast_string_field_release_active(*pool_head, *ptr);
 		mgr->last_alloc = *ptr = target;
 		AST_STRING_FIELD_ALLOCATION(target) = needed;
+#if defined __sparc__ || defined __arm__
+		(*pool_head)->used += needed + sizeof(ast_string_field_allocation) + align;
+#else
 		(*pool_head)->used += needed + sizeof(ast_string_field_allocation);
+#endif
 		(*pool_head)->active += needed;
 	} else if ((grow = (needed - AST_STRING_FIELD_ALLOCATION(*ptr))) > 0) {
 		/* the allocation was satisfied by using available space in the pool *and*
